/*C****************************************************************************
* $RCSfile: test_int.c,v $
*------------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*------------------------------------------------------------------------------
* J:			$Name: ballast-valid-si-1_0_0 $
* :			$Revision: 1.2 $
* ̧CVSID:	$Id: test_int.c,v 1.2 2004/08/25 15:31:49 raubree Exp $
*------------------------------------------------------------------------------
* ړI:
* ̧قPSCg`𐶐۸т񋟂܂B
******************************************************************************/

/*_____ ݸٰ _____________________________________________________________*/
#include "lib_mcu/compiler.h"
#include "lib_mcu/mcu.h"

#define DEAD_TIME_0		100
#define ON_TIME_0		2400
#define DEAD_TIME_1		200
#define ON_TIME_1		1300

  unsigned char Fault = 0;
  unsigned char Ent = 0;

  /* ċN荞݂IɂSW1ĂB */
  /* ̍Ōł̊荞݂IɂSW2ĂB */

  /* PEͽɐڑ܂B */
  /* PDLEDɐڑ܂B */

/*F****************************************************************************
* NAME: PSC1荞
******************************************************************************/
#pragma vector = (PSC1_CAPT_vect)
__interrupt void PSC1_Capture_IT(void)
{
//  PIFR1 = (1<<PEV1B);
  PIFR1 = 0x1F;					// PSC֌W荞ݗv׸މ
  Ent++;						// 荞݌vis
  Ent = Ent & 0xF;				// Kۂ
  PORTD = ~((Ent<<4)|Fault);	// LED\
}

#pragma vector = (PSC1EC_vect)
__interrupt void PSC1_End_Cycle_IT(void)
{
  PIFR1 = 0x1F;					// PSC֌W荞ݗv׸މ
  Ent++;						// 荞݌vis
  Ent = Ent & 0xF;				// Kۂ
  PORTD = ~((Ent<<4)|Fault);	// LED\
}

/*F**************************************************************************
* NAME: PSC1
*****************************************************************************/
void PSC1_Init (void)
{
  PSOC1 = (1<<POEN1A)|(1<<POEN1B);
  OCR1SAH = HIGH(DEAD_TIME_0);
  OCR1SAL = LOW(DEAD_TIME_0);
  OCR1RAH = HIGH(ON_TIME_0);
  OCR1RAL = LOW(ON_TIME_0);
  OCR1SBH = HIGH(DEAD_TIME_1);
  OCR1SBL = LOW(DEAD_TIME_1);
  OCR1RBH = HIGH(ON_TIME_1);
  OCR1RBL = LOW(ON_TIME_1);
  PCNF1 = (1<<PMODE11)|(1<<POP1);
  PFRC1A = (1<<PCAPE1A)|(0<<PISEL1A)|(1<<PELEV1A)|(1<<PRFM1A3);
  PFRC1B = 0;
  PCTL1 = (1<<PRUN1);						/* s !! */
}

/*F**************************************************************************
* NAME: main
*****************************************************************************/
int main (void)
{
  PSC1_Init();								// PSC1
  PIM1 = (1<<PEVE1A);						// PSC1Oۊ荞݂̂݋
  Enable_interrupt();						// S̊荞݋

  PORTD = 0xFF;								// SLED
  DDRD = 0xFF;								// SLEDp߰ďo͐ݒ
  while(1)
  {
	if (bit_is_clear(PINE,PINE1))			// PE1(SW1)=LŁA
	{
	  while (bit_is_clear(PINE,PINE1));		// PE1(SW1)Jҋ@
	  PIM1 = (1<<PEVE1A);					// PSC1Oۊ荞݂̂݋
	}
	if (bit_is_clear(PINE,PINE2))			// PE2(SW2)=LŁA
	{
	  while (bit_is_clear(PINE,PINE2));		// PE2(SW2)Jҋ@
	  PIM1 = (1<<PEOPE1);					// PSCI荞݂̂݋
	}
  }
}
